Package htsjdk.beta.io.bundle

# Class InputStreamResource

java.lang.Object
htsjdk.beta.io.bundle.BundleResourceBase
htsjdk.beta.io.bundle.InputStreamResource

All Implemented Interfaces:
  `BundleResource`, `Serializable`

Direct Known Subclasses:
  `SeekableStreamResource`

public class InputStreamResource extends BundleResourceBase
A `BundleResource` backed by an `InputStream`.

See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`InputStreamResource(InputStream inputStream, String displayName, String contentType)`
Create a `BundleResource` backed by an InputStream.
`InputStreamResource(InputStream inputStream, String displayName, String contentType, String format)`
Create a `BundleResource` backed by an InputStream, specifying a display name, content type, and format.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object o)`
`Optional<InputStream>`
`getInputStream()`
Get an `InputStream` for this resource, or Optional.empty.
`SignatureStream`
`getSignatureStream(int signatureProbeLength)`
Get a `SignatureStream` for this resource.
`int`
`hashCode()`
`boolean`
`hasInputType()`
Return true if is this resource is backed by a type that can be used for input.
`String`
`toString()`

### Methods inherited from class htsjdk.beta.io.bundle.BundleResourceBase

`getContentType, getDisplayName, getFileFormat, getIOPath, getOutputStream, getSeekableStream, hasOutputType, hasSeekableStream`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### InputStreamResource

public InputStreamResource(InputStream inputStream, String displayName, String contentType)
Create a `BundleResource` backed by an InputStream. Note that it is the caller's responsibility to ensure that `inputStream` is closed once the resulting resource is no longer being used.

Parameters:
  `inputStream` - The `InputStream` to use for this resource. May not be null.
  `displayName` - The display name for this resource. May not be null or 0-length.
  `contentType` - The content type for this resource. May not be null or 0-length.

### InputStreamResource

public InputStreamResource(InputStream inputStream, String displayName, String contentType, String format)
Create a `BundleResource` backed by an InputStream, specifying a display name, content type, and format. Note that it is the caller's responsibility to ensure that `inputStream` is closed once the resulting resource is no longer being used.

Parameters:
  `inputStream` - The `InputStream` to use for this resource. May not be null.
  `displayName` - The display name for this resource. May not be null or 0-length.
  `contentType` - The content type for this resource. May not be null or 0-length.
  `format` - The format for this resource. May not be null or 0-length.

## Method Details

### getInputStream

public Optional<InputStream> getInputStream()
Description copied from interface: `BundleResource`
Get an `InputStream` for this resource, or Optional.empty.

Specified by:
  `getInputStream` in interface `BundleResource`
Overrides:
  `getInputStream` in class `BundleResourceBase`
Returns:
  an `InputStream` for this resource, or Optional.empty if `BundleResource.hasInputType()` is false for this resource. The stream returned by this method may be buffered or use read-ahead, which may not be suitable for applications such as index creation that need control over the position of the underlying stream.

### getSignatureStream

public SignatureStream getSignatureStream(int signatureProbeLength)
Description copied from interface: `BundleResource`
Get a `SignatureStream` for this resource. This method requires access to the first `signatureProbeLength` bytes of the underlying resource. `BundleResource` implementations that are backed by raw streams that can only be consumed once, such as `InputStreamResource`, may consume and buffer a portion of the underlying resource's stream in order to allow subsequent callers of the `BundleResource.getInputStream()`) method to be presented with the entire stream, including the signature. Calls to this method may have the side effect of changing or resetting the current position of the underlying stream; serial calls to `BundleResource.getSignatureStream(int)` on the same object are not necessarily idempotent; and implementations are free to throw to prevent serial calls to this method.

Parameters:
  `signatureProbeLength` - the number of bytes of the underlying resource to include in the `SignatureStream` stream. `signatureProbeLength` should be expressed in "compressed(/encrypted)" space rather than "plaintext" space. For example, a file format signature may consist of `n` bytes of ASCII, but for formats that use compressed streams, the codec may need access to an entire compressed block in order to inspect those `n` bytes. `signatureProbeLength` should use the compressed block size, in order to ensure that the `SignatureStream` contains a semantically meaningful fragment of the underlying input.
Returns:
  a `SignatureStream` over the first `signatureProbeLength` bytes of this resource, for use with signature probing for codec resolution. Only applicable to resources for which `BundleResource.hasInputType()` is true.

### hasInputType

public boolean hasInputType()
Description copied from interface: `BundleResource`
Return true if is this resource is backed by a type that can be used for input. Some resource types, such as `InputStreamResource`, can be used for input but not for output (see `BundleResource.hasOutputType()`. Others, such as `OutputStreamResource`, can be used for output but not for input. Some resource types may be suitable for both (for example see `IOPathResource`).

The determination is based only on the type of the resource, and does not imply a guarantee about whether the resource type is actually readable.

Specified by:
  `hasInputType` in interface `BundleResource`
Overrides:
  `hasInputType` in class `BundleResourceBase`
Returns:
  true if the type of this resource makes it suitable for use as a source of input.

### equals

public boolean equals(Object o)

Overrides:
  `equals` in class `BundleResourceBase`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `BundleResourceBase`

### toString

public String toString()

Overrides:
  `toString` in class `BundleResourceBase`